/*======================================AI写真======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
	"strconv"
	"time"
)

func MD5ProtraitAi(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	PreviewUrl := "https://swapface-api.segapi.com/swapface"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["source_url"] = "https://ts-mmqi-1259176759.cos.ap-beijing.myqcloud.com/aliyun_api_img/source_img.jpg" //用户原图
	data["target_url"] = "https://ts-mmqi-1259176759.cos.ap-beijing.myqcloud.com/aliyun_api_img/target_img.jpg" //模板图
	data["notify_url"] = "https://www.baidu.com"                                                                //回调地址

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", PreviewUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5ProtraitAi(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)
	currentTimestampMillis := time.Now().UnixNano() / int64(time.Millisecond)
	currentTimestampMillisStr := strconv.FormatInt(currentTimestampMillis, 10)
	req.Header.Set("X-Ca-Nonce", currentTimestampMillisStr) // 请求标示 推荐使用uuid

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
